//Copyright (c) 2009 Gabriel See
//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software and associated documentation files (the "Software"), to deal
//in the Software without restriction, including without limitation the rights
//to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//copies of the Software, and to permit persons to whom the Software is
//furnished to do so, subject to the following conditions:

//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.

//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.

//PHI LegoRoboBrick
//Put this file in the PHI directory, and BT.h in the ALPHA directory.
#include "MCLib/MCLib.c"
#include "../Alpha/BT.h"

typedef short Tmutex;
task main;
Tmutex mutex1;
bool pumped;
void amutex (Tmutex &mutex);
void rmutex (Tmutex &mutex);

void aspirate (int amount);
void dispense ();
void clean ();

task pump;
task main()
{
	int c;
	int iMsg, iMsgParam1;

	mutex1=0;
	MCInit(motorA, motorB);//Switch, Pump
	MCFindLimit(motorA,50);
	MCFindLimit(motorB,50);
	MCStart();
	MCSetTarget(motorA,-55);
	wait1Msec(500);
	StartTask(pump);

	// Clear the message queue in case there are old messages waiting to be processed
  while (bQueuedMsgAvailable())
  {
    ClearMessage();   // Were ready to process the next message
  }

  while (true)
  {
  	c = 0;
    // Wait for message
  	while (!bQueuedMsgAvailable())
  	{
  		c++;
  		nxtDisplayTextLine(6, "WaitMsg%i", c);
	    // No message is available to process
	    wait1Msec(5);
	  }

	  // A message is ready to be processed
	  iMsg = message;          // the value of S1 from the remote NXT
//	  iMsgParam1 = messageParm[1];   // the value of S2 from the remote NXT . . . user code to process the message. It may have many delays.

	  nxtDisplayTextLine(6, "iMsg=%i", iMsg);
	  switch(iMsg)
	  {
	  	case BT_ASPIRATE:
	  	  iMsgParam1 = messageParm[1];
		    nxtDisplayTextLine(7,"Aspirate %i ", iMsgParam1);
	  	  aspirate(iMsgParam1);
	      ClearMessage();
	      //sendMessageWithParm(BT_DONE);
	  	  break;
	  	case BT_DISPENSE:
	  	  nxtDisplayTextLine(7,"Dispensing");
	  	  dispense();
	      ClearMessage();
	      //sendMessageWithParm(BT_DONE);
	  	  break;
	  	case BT_CLEAN:
	  	  nxtDisplayTextLine(7,"Cleaning  ");
	  	  clean();
	      ClearMessage();
	      //sendMessageWithParm(BT_DONE);
	  	  break;
	  }
	}
}
task pump()
{
	amutex(mutex1);
	pumped=false;
	rmutex(mutex1);
	while(true)
	{
		if (!pumped)
		{
			amutex(mutex1);
			motor[motorC]=100;
			wait1Msec(4000);
			motor[motorC]=0;
			pumped=true;
			rmutex(mutex1);
		}
	}
}
void amutex (Tmutex &mutex)//acquire mutex
{
	while(true)
	{
	  mutex++;
	  if (mutex==1) return;
	  mutex--;
	  wait1Msec(50);
	}
}
void rmutex (Tmutex &mutex)//release mutex
{
	mutex--;
}

void aspirate (int amount)
{
	MCSetTarget(motorB,-55-amount);
	wait1Msec(1000);
}
void dispense ()
{
	MCSetTarget(motorB,0);
	wait1Msec(1000);
	MCSetTarget(motorA,-110);
	wait1Msec(1000);
	MCSetTarget(motorB,-55);
	wait1Msec(1000);
	MCSetTarget(motorA,-30);
	wait1Msec(1000);
	MCSetTarget(motorA,-55);
	wait1Msec(1000);
}
void clean ()
{
	bool cleaned;
	cleaned=false;
	while (!cleaned)
	{
		amutex(mutex1);
		if (pumped)
		{
			MCSetTarget(motorA,0);
			cleaned=true;
		}
		rmutex(mutex1);
		wait1Msec(1000);
	}
	MCSetTarget(motorA,-65);
	wait1Msec(1000);
	amutex(mutex1);
	pumped=false;
	rmutex(mutex1);
}
